/**
 * 添加推荐人
 */
define("project/scripts/account/addAppoint",function(require, exports, module){
	var appUtils = require("appUtils"),
		service = require("serviceImp").getInstance(),  //业务层接口，请求数据
		validatorUtil = require("validatorUtil"),
		layerUtils = require("layerUtils"),
		utils = require("utils"),
		_pageId = "#account_addAppoint";
	
	function init()
	{
       require("shellPlugin").callShellMethod("sharePrefGetPlugin",function(result){
             if(!validatorUtil.isEmpty(result.oa))
                $(_pageId+" #oa").val(result.oa);
       },null,null);
	}

	function bindPageEvent()
	{
		/* 绑定返回 */
		appUtils.bindEvent($(_pageId+" .header .icon_back"),function(){
			appUtils.pageBack();
		});

		/* 绑定确定 */
		appUtils.bindEvent($(_pageId+" .fix_bot .ct_btn"),function(){
			 var oa = $(_pageId+" #oa").val().trim();
			 if(validatorUtil.isEmpty(oa))
             {
            	 layerUtils.iMsg(-1,"推荐人OA账号不能为空!");
            	 return;
             }
			//客户根据OA查询客户经理信息
            var parameter = {
                "i_login_name" : oa
            };
            service.queryAssistByOA(parameter,function(data){
                if(data.error_no != 0){
                   layerUtils.iLoading(false);
                   layerUtils.iAlert(data.error_info,-1);
                   return;
                }
                var result = data.results[0];
                if(result!=null && result!="" && typeof(result)!=undefined) {
                	var name = result.user_name;
                	var dept = result.branch_name;
                	utils.layerTwoButton("您的开户推荐人："+name+"，<br/>开户营业部："+dept,"确认","取消",function(){
                			//客户根据OA预约开户
                            var param = {
                                    "i_login_name" : oa,
                                    "i_mobile" : appUtils.getSStorageInfo("mobileNo"),
                                    "i_activity_id" : "6694"
                             };
                             //预约开户
                             service.appointUserByOA(param,function(data){
                                  if(data.error_no != 0){
                                      layerUtils.iLoading(false);
                                      layerUtils.iAlert(data.error_info,-1);
                                      return;
                                  }
                                   var result = data.results[0];
                                   if(result!=null && result!="" && typeof(result)!=undefined) {
                                      appUtils.setSStorageInfo("oa",oa);
                                      appUtils.setSStorageInfo("assistant",name);
                                      require("shellPlugin").callShellMethod("sharePrefSetPlugin",null,null,{"oa":oa, "name":name});
                                      appUtils.pageInit("account/addAppoint","account/personInfo");
                                  } else{
                                       layerUtils.iAlert("没有查询到该推荐人！",-1);
                                  }
                             },false,false);

                    }, function(){return false;});
                } else{
                    layerUtils.iAlert("没有查询到该推荐人！",-1);
                }
            },false,false);
		});
	}
	
	function destroy()
	{

	}
	
	var addAppoint = {
		"init" : init,
		"bindPageEvent" : bindPageEvent,
		"destroy" : destroy
	};
	
	// 暴露对外的接口
	module.exports = addAppoint;
});