/**
 * 查看网络营业部和就近营业部区别
 */
define("project/scripts/account/branchMap",function(require, exports, module){
	var appUtils = require("appUtils"),
       utils = require("utils"),
       global = require("gconfig").global,
		_pageId = "#account_branchMap";
	
	function init()
	{
       if(global.isSubSystem == "1")
       $(_pageId+" .header .icon_close").show();
		// 百度地图API功能
		var branchname = appUtils.getPageParam("branchname");
		var lat = appUtils.getPageParam("lat");
		var lnt = appUtils.getPageParam("lnt");
		var address = appUtils.getPageParam("address");
		var trainfo = appUtils.getPageParam("trainfo");

		if(address == null || typeof(address) == undefined)
		{
			address = "";
		}
		if(trainfo == null || typeof (trainfo) == undefined)
		{
			trainfo = "";
		}

		var sContent = "<div>"+branchname+"</br>"+address+"</br><p>"+trainfo+"</p></div>";
		var map = new BMap.Map("allmap");            // 创建Map实例
		var point = new BMap.Point(lat,lnt);
		map.addControl(new BMap.ZoomControl());//添加地图缩放控件
		var marker = new BMap.Marker(point);
		var infoWindow = new BMap.InfoWindow(sContent);  // 创建信息窗口对象
		map.openInfoWindow(infoWindow,new BMap.Point(lat, (parseFloat(lnt)+0.00015))); //显示窗口信息
		map.centerAndZoom(point, 18);
		map.addOverlay(marker);//标注点
		marker.addEventListener("click", function(){
			this.openInfoWindow(infoWindow);
		});
	}
	
	function bindPageEvent()
	{
       /* 绑定退出按钮*/
       appUtils.bindEvent($(_pageId+" .header .icon_close"),function(){
                          utils.layerTwoButton("退出手机开户？","确认","取消",function(){
                                               require("shellPlugin").callShellMethod("closeAppPlugin",null,null);  // 退出程序
                                               },
                                               function(){return false;});
                          });
		/* 绑定返回 */
		appUtils.bindEvent($(_pageId+" .header .icon_back"),function(){
			appUtils.pageBack();
		});
		
		/* 绑定知道了 */
		appUtils.bindEvent($(_pageId+" .fix_bot .ct_btn"),function(){
			appUtils.pageBack();
		});
	}
	
	function destroy()
	{
		
	}
	
	var introDepartment = {
		"init" : init,
		"bindPageEvent" : bindPageEvent,
		"destroy" : destroy
	};
	
	// 暴露对外的接口
	module.exports = introDepartment;
});