/**
 * 手机号码验证
 */
define("project/scripts/account/msgCode", function(require, exports, module) {
	/* 私有业务模块的全局变量 begin */
	var appUtils = require("appUtils"),
		service = require("serviceImp").getInstance(), //业务层接口，请求数据
		global = require("gconfig").global,
		layerUtils = require("layerUtils"),
		utils = require("utils"),
		validatorUtil = require("validatorUtil"),
		startCountDown = null,
		clearCountDown = null,
		sbmNum = global.sbmNum,
		isPassed = false,
		isFlag = 0;
	_pageId = "#account_msgCode",
		psw_id = "", key = 1, flag = false,
		steps = ["uploadimg", "idconfirm", "witness",
			"certintall", "risksurvey", "capitalacct",
			"stkacct", "setpwd", "tpbank",
			"visitsurvey", "affirm", "success"
		],
		stepMap = {
			"uploadimg": "account/uploadPhoto",
			"idconfirm": "account/personInfo",
			"witness": "account/videoNotice",
			"certintall": "account/digitalCertificate",
			"risksurvey": "account/riskAssessment",
			"capitalacct": "account/signProtocol",
			"stkacct": "account/signProtocol",
			"setpwd": "account/setPwd",
			"tpbank": "account/thirdDepository",
			"visitsurvey": "account/openConfirm",
			"affirm": "account/receiptInfo",
			"success": "account/accountResult"
		},
		stepMap0 = {
			"uploadimg": "account/uploadPhotoChange",
			"witness": "account/digitalCertificate"
		};
	var mobile_no = "";
	var serial_no = "";
	var content = "语音验证码请求成功，请等待语音验证码电话...";
	/* 私有业务模块的全局变量 end */
	var isNav = (window.navigator.appName.toLowerCase().indexOf("netscape") >= 0);
	var isIE = (window.navigator.appName.toLowerCase().indexOf("microsoft") >= 0);

	function init() {
		/*发送验证码后自动互调该方法*/
		if (global.isSubSystem == "1")
			$(_pageId + " .header .icon_close").show();

		window.getCode = getCode;
		mobile_no = appUtils.getPageParam("mobile_no");
		$(_pageId + " .top_title #b_mobile").html(mobile_no);
		appUtils.setSStorageInfo("flag", "1"); //如果数据字典内没有配置证书标识
		checkCertificate(); //查询书否需要证书  
		$(_pageId + " .cert_notice").hide();
		$(_pageId + " .time").hide();
		$(_pageId + " .time").text(60);
		$(_pageId + " .voice_notice").hide();
		$(_pageId + " .pop-box").hide();
		serial_no = "";
		// 清除计时器
		if (startCountDown != null) {
			window.clearInterval(startCountDown);
		}
		sendCode();
	}

	/*
	 * 查询书否需要证书
	 * */
	function checkCertificate() {
		var param = {};
		service.checkCertificate(param, function(data) {
			var error_no = data.error_no;
			var error_info = data.error_info;
			var result = data.results;
			if (error_no == "0") {
				if (result.length == 1) {
					appUtils.setSStorageInfo("flag", result[0].cur_value);
				} else {
					layerUtils.iAlert("系统异常，请联系管理员！", -1);
					return false;
				}
			} else {
				layerUtils.iAlert("系统异常，请联系管理员！", -1);
				return false;
			}
		});
	}

	function bindPageEvent() {

		var inputYzm = document.getElementById("ipt");
		inputYzm.addEventListener("keyup", inputForward, false);
		inputYzm.addEventListener("input", inputInput, false);

//		appUtils.bindEvent($(_pageId + "  #ipt"), clickInput);
//		appUtils.bindEvent($(_pageId + "  .input-yzm"), clickInput);
		

		/* 绑定返回事件 */
		appUtils.bindEvent($(_pageId + " .header .icon_back"), function() {
			//appUtils.pageBack();
			if (!$(_pageId + " .time").is(":hidden")) {
				layerUtils.iMsg(-1, "请在验证码计时完毕后再回退！");
			} else if (!$(_pageId + " .voice_notice").is(":hidden")) {
				layerUtils.iMsg(-1, "请在语音验证码请求完毕后再回退！");
			} else {
				appUtils.pageInit("account/msgCode", "account/msgVerify", {});
			}
		});

		/* 语音验证弹窗 */
		appUtils.bindEvent($(_pageId + " .main  #voiceYz"), function() {
			$(_pageId + " .pop-box").show();
		});

		/* 关闭语音验证弹窗 */
		appUtils.bindEvent($(_pageId + " .pop-box  .tel-pop .close"), function() {
			$(_pageId + " .pop-box").hide();
		});

		/* 绑定退出按钮*/
		appUtils.bindEvent($(_pageId + " .header .icon_close"), function() {
			utils.layerTwoButton("退出手机开户？", "确认", "取消", function() {
					require("shellPlugin").callShellMethod("closeAppPlugin", null, null); // 退出程序
				},
				function() {
					return false;
				});
		});

		/* 下一步(继续开户) */
		appUtils.bindEvent($(_pageId + " .fix_bot .ct_btn"), function() {
			if (mobile_no.length == 0) {
				layerUtils.iMsg(-1, "手机号码错误！");
				return;
			}
			if (document.getElementById("ipt").value.length < 4) {
				layerUtils.iMsg(-1, "请输入验证码！");
				return;
			}
			if (!validatorUtil.isMobile(mobile_no)) {
				layerUtils.iMsg(-1, "请输入正确的手机号码！");
				return;
			}
			checkSmsCode(); //验证码校验
		});
		/* 语音验证开始 */
		appUtils.bindEvent($(_pageId + " .pop-box  #yz_voice"), function() {
			//alert("调用语音验证码功能号");
			var phoneNum = mobile_no;
			// 首先验证手机号
			if (validatorUtil.isMobile(phoneNum)) {
				getSmsCode("2", phoneNum); //获取验证码
			} else {
				// 手机号没通过前端校验，弹出提示，并终止发送验证码的过程
				var times = phoneNum.length - 11;
				if (phoneNum.length > 11) {
					layerUtils.iMsg(-1, "您多输入&nbsp;" + times + "&nbsp;位手机号码，请重新输入！");
				} else if (phoneNum.length < 11) {
					layerUtils.iMsg(-1, "您少输入&nbsp;" + Math.abs(times) + "&nbsp;位手机号码，请重新输入！");
				} else {
					layerUtils.iMsg(-1, "请输入正确格式的手机号码！");
				}
				return;
			}
		});
	}

	function inputInput(e) {
		var numLen = 4;
		var input = document.getElementById("ipt");
		var pw = input.value;
		var list = $('.cell');
		for (var i = 0; i < numLen; i++) {
			if (pw[i]) {
				$(list[i]).text(pw[i]);
			} else {
				$(list[i]).text('');
			}
		}
	}

	function inputForward(e) {
		var target = e.target;
		if (target.value.length === target.maxLength) {
			//alert("自动验证验证码");
			if (mobile_no.length == 0) {
				layerUtils.iMsg(-1, "手机号码错误！");
				return;
			}
			if (!validatorUtil.isMobile(mobile_no)) {
				layerUtils.iMsg(-1, "请输入正确的手机号码！");
				return;
			}
			$(_pageId + " .time").hide();
			$(_pageId + " .cert_notice").hide();
			$(_pageId + " .time").text(60);
			if (startCountDown != null) {
				window.clearInterval(startCountDown);
			}
			checkSmsCode(); //验证码校验
		}
	}

	function clickInput(e) {
		window.setInterval(function() {
			var input = document.getElementById("ipt");
			var val = input.value;
			input.focus();
			input.value = '';
			input.value = val;
		}, 500);

	}

	function tabForward(e) {
		e = e || window.event;
		var target = e.target || e.srcElement;
		if (target.value.length === target.maxLength) {
			var form = target.form;
			for (var i = 0, len = form.elements.length - 1; i < len; i++) {
				if (form.elements[i] === target) {
					if (form.elements[i++]) {
						form.elements[i++].focus();
					}
					break;
				} else if (i == (len - 1)) {
					//alert("自动验证验证码");
					if (mobile_no.length == 0) {
						layerUtils.iMsg(-1, "手机号码错误！");
						return;
					}
					if (document.getElementById("ipt").value.length < 4) {
						layerUtils.iMsg(-1, "请输入验证码！");
						return;
					}
					if (!validatorUtil.isMobile(mobile_no)) {
						layerUtils.iMsg(-1, "请输入正确的手机号码！");
						return;
					}
					$(_pageId + " .time").hide();
					$(_pageId + " .cert_notice").hide();
					$(_pageId + " .time").text(60);
					if (startCountDown != null) {
						window.clearInterval(startCountDown);
					}
					checkSmsCode(); //验证码校验
					break;
				}
			}
		}
	}

	function sendCode() {
		var phoneNum = mobile_no;
		//alert(phoneNum);
		// 首先验证手机号
		if (validatorUtil.isMobile(phoneNum)) {
			getSmsCode("1", phoneNum); //获取验证码
		} else {
			// 手机号没通过前端校验，弹出提示，并终止发送验证码的过程
			var times = phoneNum.length - 11;
			if (phoneNum.length > 11) {
				layerUtils.iMsg(-1, "您多输入&nbsp;" + times + "&nbsp;位手机号码，请重新输入！");
			} else if (phoneNum.length < 11) {
				layerUtils.iMsg(-1, "您少输入&nbsp;" + Math.abs(times) + "&nbsp;位手机号码，请重新输入！");
			} else {
				layerUtils.iMsg(-1, "请输入正确格式的手机号码！");
			}
			return;
		}
	}

	function destroy() {
		// 清除计时器
		if (startCountDown != null) {
			window.clearInterval(startCountDown);
		}
		if (clearCountDown != null) {
			window.clearInterval(clearCountDown);
		}
		$(_pageId + " .cert_notice").hide(); // 隐藏验证码已发出提示
		document.getElementById("ipt").value = "";
		var list = $('.cell');
		for (var i = 0; i < 4; i++) {
			$(list[i]).text('');
		}
		service.destroy();
	}

	/* 壳子获取验证码自动填充 */
	function getCode(data) {
		if (data && !isPassed) {
			document.getElementById("ipt").value = data;
			var numLen = 4;
		    var pw = data;
		    var list = $('.cell');
		    for (var i = 0; i < numLen; i++) {
			   if (pw[i]) {
				   $(list[i]).text(pw[i]);
			    } else {
				   $(list[i]).text('');
				}
			}
		}
	}

	/* 获取验证码 */
	function getSmsCode(type, phoneNum) {
		var mac = iBrowser.pc ? "02:00:5E:00:00:14" : "",
			ip = iBrowser.pc ? "192.168.1.109" : "";
		// 只有当不是 pc 时，才调用壳子获取 ip 和 mac
		if (!iBrowser.pc) {
			require("shellPlugin").callShellMethod("getIpMacPLugin", function(data) {
				data = data.split("|");
				mac = data[0];
				ip = data[1];
				uuid = data[2];
				appUtils.setSStorageInfo("ip", ip); // 将 ip 保存到 sessionStorage 里面
				appUtils.setSStorageInfo("mac", mac); // 将 mac 保存到 sessionStorage 里面
				if (type == "1") {
					sendmsg(type, phoneNum, mac, ip, uuid); // 发送验证码
				} else {
					sendVoicemsg(type, phoneNum, mac, ip, uuid); // 发送语音验证码
				}
			}, null);
		} else {
			if (type == "1") {
				sendmsg(type, phoneNum, mac, ip, ""); // 发送验证码
			} else {
				sendVoicemsg(type, phoneNum, mac, ip, ""); // 发送语音验证码
			}
		}
	}

	/* 发送验证码 */
	function sendmsg(type, phoneNum, mac, ip, uuid) {
		var param = {
			// 访问接口来源标识，访问来源(默认PC) 0：pc， 2：pad， 3：手机 
			"op_way": iBrowser.pc ? 0 : 3,
			"mobile_no": phoneNum,
			"ip": ip,
			"mac": mac,
			"i_device_type": iBrowser.pc ? 1 : 3,
			"i_type": type,
			"i_device_code": uuid

		};
		//请求获取验证码接口
		service.getSmsCodeNew(param, function(data) {
			var error_no = data.error_no;
			var error_info = data.error_info;
			var result = data.results;
			if (error_no == "0") {
				//后台如果返回ip地址，则本地存储用户ip地址
				if (result[0] && result[0].ip) {
					appUtils.setSStorageInfo("ip", result[0].ip);
				}
				if (result[0] && result[0].serial_no) {
					serial_no = result[0].serial_no;
				}
				// 计时器
				var sumTime = 60;
				//处理获取验证码时发生的动作
				var handleCount = function() {
					// 显示倒计时
					$(_pageId + " .time").show();
					$(_pageId + " .cert_notice").show();
					$(_pageId + " .time").text(sumTime-- + "");
				};
				handleCount();
				startCountDown = window.setInterval(function() {
					handleCount();
				}, 1000);
				// 60 秒之后清除计时器
				clearCountDown = setTimeout(function() {
					// 隐藏倒计时
					$(_pageId + " .time").hide();
					$(_pageId + " .cert_notice").hide();
					$(_pageId + " .time").text(60);
					window.clearInterval(startCountDown);
					$(_pageId + " .pop-box").show();
				}, 61000);
				// 调用读取短信验证码插件
				require("shellPlugin").callShellMethod("sMSReceiverPlugin", null, null, null);
			} else {
				serial_no = "";
				layerUtils.iAlert(error_info, -1);
				return false;
			}
		});
	}

	/* 发送验证码 */
	function sendVoicemsg(type, phoneNum, mac, ip, uuid) {
		var param = {
			// 访问接口来源标识，访问来源(默认PC) 0：pc， 2：pad， 3：手机 
			"op_way": iBrowser.pc ? 0 : 3,
			"mobile_no": phoneNum,
			"ip": ip,
			"mac": mac,
			"i_device_type": iBrowser.pc ? 1 : 3,
			"i_type": type,
			"i_device_code": uuid

		};
		//请求获取验证码接口
		service.getSmsCodeNew(param, function(data) {
			var error_no = data.error_no;
			var error_info = data.error_info;
			var result = data.results;
			if (error_no == "0") {
				//后台如果返回ip地址，则本地存储用户ip地址
				if (result[0] && result[0].ip) {
					appUtils.setSStorageInfo("ip", result[0].ip);
				}
				if (result[0] && result[0].serial_no) {
					serial_no = result[0].serial_no;
				}
				if (result[0] && result[0].content) {
					content = result[0].content;
				}
				$(_pageId + " .pop-box").hide();
				// 计时器
				var handleCount = function() {
					$(_pageId + " .voice_notice").show();
					$(_pageId + " .voice_notice  #voice_info").html(content);
				};
				handleCount();
				startCountDown = window.setInterval(function() {
					handleCount();
				}, 1000);
				// 20 秒之后清除计时器
				clearCountDown = setTimeout(function() {
					// 隐藏倒计时
					$(_pageId + " .voice_notice").hide();
					window.clearInterval(startCountDown);
				}, 20000);
			} else {
				serial_no = "";
				layerUtils.iAlert(error_info, -1);
				return false;
			}
		});
	}

	/* 提交验证码校验 */
	function checkSmsCode() {
		var login_flag = appUtils.getSStorageInfo("openChannel") == "new" ? "0" : "1";
		if (appUtils.getSStorageInfo("finance") == "finance") {
			login_flag = "2"; // 理财户传2
		}
		var code = document.getElementById("ipt").value;
		var param = {
			"mobile_no": mobile_no,
			"mobile_code": code,
			"serial_no": serial_no,
			"login_flag": login_flag, // 登录业务标准，新开户0  转户1  理财户2
			"infocolect_channel": iBrowser.pc ? 0 : 3 // 信息来源渠道 0：PC  3：手机

		};
		/*调用验证码校验接口*/
		service.checkSmsCode(param, function(data) {
			var error_no = data.error_no;
			var error_info = data.error_info;
			var result = data.results;
			if (error_no == "0" && result.length != 0) {
				serial_no = "";
				isPassed = true;
				// user_id保存到session
				if (result[0].user_id) {
					appUtils.setSStorageInfo("user_id", result[0].user_id);
				}
				// 身份证号保存到session
				if (result[0].idno) {
					appUtils.setSStorageInfo("idCardNo", result[0].idno);
				}
				//手机号保存到session
				if (result[0].mobileno) {
					appUtils.setSStorageInfo("mobileNo", result[0].mobileno);
				}
				// 将客户姓名保存到 session 中
				if (result[0].custname) {
					appUtils.setSStorageInfo("custname", result[0].custname);
				}
				// 签发机关保存到session 
				if (result[0].policeorg) {
					appUtils.setSStorageInfo("policeorg", result[0].policeorg);
				}
				// 证件地址保存到session 
				if (result[0].native) {
					appUtils.setSStorageInfo("native", result[0].native);
				}
				// 联系地址保存到session 
				if (result[0].addr) {
					appUtils.setSStorageInfo("addr", result[0].addr);
				}
				// 起始期限保存到session 
				if (result[0].idbegindate) {
					appUtils.setSStorageInfo("idbegindate", result[0].idbegindate);
				}
				// 结束期限保存到session 
				if (result[0].idenddate) {
					appUtils.setSStorageInfo("idenddate", result[0].idenddate);
				}
				// 邮编保存到session 
				if (result[0].postid) {
					appUtils.setSStorageInfo("postid", result[0].postid);
				}
				// 职业保存到session 
				if (result[0].profession_code) {
					appUtils.setSStorageInfo("profession_code", result[0].profession_code);
				}
				// 学历保存到session 
				if (result[0].edu) {
					appUtils.setSStorageInfo("edu", result[0].edu);
				}
				// 学历保存到session
				if (result[0].urgentphone) {
					appUtils.setSStorageInfo("urgentphone", result[0].urgentphone);
				}
				// 将 clientinfo 保存到 session 中，用于解决壳子上传照片的权限问题
				if (result[0].clientinfo) {
					appUtils.setSStorageInfo("clientinfo", result[0].clientinfo);
				}
				// 将 jsessionid 保存到 session 中，用于解决壳子上传照片的权限问题
				if (result[0].jsessionid) {
					appUtils.setSStorageInfo("jsessionid", result[0].jsessionid);
				}
				// 将佣金id保存到session
				if (result[0].commission) {
					appUtils.setSStorageInfo("commission", result[0].commission);
				}
				// 将佣金值保存到session
				if (result[0].commissionname) {
					appUtils.setSStorageInfo("commissionname", result[0].commissionname);
				}
				// 将营业部Id保存到session
				if (result[0].branchno && result[0].branchno != "0") {
					appUtils.setSStorageInfo("branchno", result[0].branchno);
				}
				// 将营业部名称保存到session
				if (result[0].branchname) {
					appUtils.setSStorageInfo("branchname", result[0].branchname);
				}

				// 将省份保存到session
				if (result[0].provincename) {
					appUtils.setSStorageInfo("provincename", result[0].provincename);
				}
				// 将城市保存到session
				if (result[0].cityname) {
					appUtils.setSStorageInfo("cityname", result[0].cityname);
				}
				appUtils.setSStorageInfo("shaselect", result[0].shaselect); // 是否选择沪A
				appUtils.setSStorageInfo("szaselect", result[0].szaselect); // 是否选择深A
				appUtils.setSStorageInfo("hacnselect", result[0].shaselect); // 是否选择沪开放式基金
				appUtils.setSStorageInfo("zacnselect", result[0].szaselect); // 是否选择深开放式基金
				var opacctkind_flag = result[0].opacctkind_flag; // 开户通道的标识，0 新开户，1 转户 , 2 理财户
				// 根据 opacctkind_flag 设置 session 中的 openChannel
				if (opacctkind_flag == 0) {
					appUtils.setSStorageInfo("openChannel", "new");
				} else {
					//不存在转户, 都按新开流程走
					appUtils.setSStorageInfo("openChannel", "new");
				}
				//判断是否驳回，若驳回 则走驳回流程
				if (addition(result[0])) {
					return false;
				}
				//未驳回，则正常走流程
				else {
					nextStep(result[0], opacctkind_flag);
				}
			} else {
				layerUtils.iMsg(-1, "您尚未通过手机号码验证，请重新提交验证码！");
			}
		});
	}

	/* 处理驳回补全资料的情况 */
	function addition(res) {
		//驳回情况：身份证正面、反面、大头像、交易密码、资金密码、三方存管、转户驳回到视频见证
		var photoParam = {
			"needFront": res.need_photo_front != undefined ? res.need_photo_front : "0",
			"needBack": res.need_photo_back != undefined ? res.need_photo_back : "0",
			"needNohat": res.need_photo_nohat != undefined ? res.need_photo_nohat : "0"
		};
		var pwdParam = {
			"needBusinessPwd": res.need_business_password != undefined ? res.need_business_password : "0",
			"needFundPwd": res.need_fund_password != undefined ? res.need_fund_password : "0"
		};
		var videoParam = {
			"need_video": res.need_video != undefined ? res.need_video : "0"
		};
		var thirdParam = {
			"needThirdDeposit": res.need_third_deposit != undefined ? res.need_third_deposit : "0"
		};
		var accountParam = {
			"need_account": res.need_account != undefined ? res.need_account : "0"
		};
		appUtils.setSStorageInfo("videoParam", JSON.stringify(videoParam));
		appUtils.setSStorageInfo("pwdParam", JSON.stringify(pwdParam));
		appUtils.setSStorageInfo("thirdParam", JSON.stringify(thirdParam));
		appUtils.setSStorageInfo("accountParam", JSON.stringify(accountParam));
		// 1.补全照片
		if (photoParam["needFront"] == 1 || photoParam["needBack"] == 1 || photoParam["needNohat"] == 1) {
			appUtils.pageInit("account/msgCode", "account/backUploadPhoto", photoParam);
			return true;
		}
		// 2.驳回视频见证
		if (videoParam["need_video"] == 1) {
			appUtils.pageInit("account/msgCode", "account/videoNotice", videoParam);
			return true;
		}
		// 3.驳回开立账户
		if (accountParam["need_account"] == 1) {
			appUtils.pageInit("account/msgCode", "account/backSignProtocol", accountParam);
			return true;
		}
		// 4.驳回密码设置
		if (pwdParam["needBusinessPwd"] == 1 || pwdParam["needFundPwd"] == 1) {
			appUtils.pageInit("account/msgCode", "account/backSetPwd", pwdParam);
			return true;
		}
		// 5.驳回三方存管
		if (thirdParam["needThirdDeposit"] == 1) {
			appUtils.pageInit("account/msgCode", "account/backThirdDepository", thirdParam);
			return true;
		} else {
			return false;
		}
	}

	/* 下一步入口 */
	function nextStep(res, opacctkind_flag) {
		var pageCode = "";
		var currentStep = res["lastcomplete_step"]; //断点：上次走的最后一步
		appUtils.setSStorageInfo("currentStep", currentStep);
		if (currentStep && currentStep.length > 0) {
			var index = steps.indexOf(currentStep);
			if (index < (steps.length - 1)) {
				if (appUtils.getSStorageInfo("flag") == "0" && currentStep == "witness") {
					currentStep = steps[index + 2];
				} else {
					currentStep = steps[index + 1];
				}
			}
			if (opacctkind_flag == "0") {
				pageCode = stepMap[currentStep];
			} else {
				pageCode = stepMap0[currentStep];
				if (!(pageCode && pageCode.length > 0)) {
					pageCode = stepMap[currentStep];
				}
			}
		}
		if (pageCode && pageCode.length > 0) {
			// 如果是直接跳转到 视频认证 页面，将 QQ 保存到 session 中
			if (pageCode == "account/videoNotice") {
				appUtils.setSStorageInfo("qq", res.im_code);
			}
			appUtils.pageInit("account/msgCode", pageCode, {});
			//					appUtils.pageInit("account/msgVerify","account/openConfirm",{});
		} else {
			appUtils.pageInit("account/msgCode", "account/uploadPhoto", {});
		}
	}

	var msgCode = {
		"init": init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};

	//暴露接口
	module.exports = msgCode;
});