/**
 * 手机号码验证
 */
define("project/scripts/account/msgVerify", function(require, exports, module) {
	/* 私有业务模块的全局变量 begin */
	var appUtils = require("appUtils"),
		service = require("serviceImp").getInstance(), //业务层接口，请求数据
		global = require("gconfig").global,
		layerUtils = require("layerUtils"),
		utils = require("utils"),
		validatorUtil = require("validatorUtil"),
		_pageId = "#account_msgVerify";

	/* 私有业务模块的全局变量 end */

	function init() {
		/*发送验证码后自动互调该方法*/
		if (global.isSubSystem == "1")
			$(_pageId + " .header .icon_close").show();
		$(_pageId + " .mobile_form .code_pic").attr("src", global.serverUrl + "/nImgServlet?key=1");
		var elements = _pageId + " .phoneNum";
		//utils.getPhoneNo(elements); // 自动获取手机号，并填充
	}

	function bindPageEvent() {

		/* 绑定返回事件 */
		appUtils.bindEvent($(_pageId + " .header .icon_back"), function() {
			//appUtils.pageBack();
			 appUtils.pageInit("account/msgVerify", "business/index", {});
		});

		/* 绑定退出按钮*/
		appUtils.bindEvent($(_pageId + " .header .icon_close"), function() {
			utils.layerTwoButton("退出手机开户？", "确认", "取消", function() {
					require("shellPlugin").callShellMethod("closeAppPlugin", null, null); // 退出程序
				},
				function() {
					return false;
				});
		});

		/* 下一步(继续开户) */
		appUtils.bindEvent($(_pageId + " .fix_bot .ct_btn"), function() {
			var phoneNum = $(_pageId + " .phoneNum").val();
			if (phoneNum.length == 0) {
				layerUtils.iMsg(-1, "请输入手机号！");
				return;
			}
			if (!validatorUtil.isMobile(phoneNum)) {
				layerUtils.iMsg(-1, "请输入正确的手机号码！");
				return;
			}
			if (phoneNum.length > 11) {
				layerUtils.iMsg(-1, "您多输入&nbsp;" + times + "&nbsp;位手机号码，请重新输入！");
				return;
			} else if (phoneNum.length < 11) {
				var times = phoneNum.length - 11;
				layerUtils.iMsg(-1, "您少输入&nbsp;" + Math.abs(times) + "&nbsp;位手机号码，请重新输入！");
				return;
			} 
			nextStep();
		});
	}

	function destroy() {
		$(_pageId + " .phoneNum").val(""); //清除手机号
		service.destroy();
	}

	/* 下一步入口 */
	function nextStep(res, opacctkind_flag) {
		var phoneNum = $(_pageId + " .phoneNum").val();
		appUtils.pageInit("account/msgVerify", "account/msgCode", {
			"mobile_no": phoneNum
		});
	}

	var msgVerify = {
		"init": init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};

	//暴露接口
	module.exports = msgVerify;
});