/**
* 开户确认（问卷回访）
*/
define("project/scripts/account/openConfirm",function(require,exports,module){
	/* 私有业务模块的全局变量 begin */
	var appUtils = require("appUtils"),
		  service = require("serviceImp").getInstance(), //业务层接口，请求数据
		  global = require("gconfig").global,
		  layerUtils = require("layerUtils"),
		  utils =  require("utils"),
		  Map = require("map"),
		  fristMap = "",
		  userId = appUtils.getSStorageInfo("user_id"),
		  protocol = null,	//保存协议
		   cert_type = appUtils.getSStorageInfo("openChannel") == "new" ? "zd" : "tw", // tw:天威 zd:中登
		  _pageId = "#account_openConfirm";
	/* 私有业务模块的全局变量 end */
		
	function init()
	{
       if(global.isSubSystem == "1")
       $(_pageId+" .header .icon_close").show();
       if(appUtils.getSStorageInfo("flag") =="1"){
			checkCert();  //检测证书是否存在
		}else{
			getOpenConfirmData();// 显示问卷和协议
		}
		fristMap = new Map();
//		getOpenConfirmData(); //获取问卷回访问题
		$(_pageId+" .icon_check").addClass("checked");  // 默认选中签署协议
		
	}
	
	function bindPageEvent()
	{
       /* 绑定退出按钮*/
       appUtils.bindEvent($(_pageId+" .header .icon_close"),function(){
                          utils.layerTwoButton("退出手机开户？","确认","取消",function(){
                                               require("shellPlugin").callShellMethod("closeAppPlugin",null,null);  // 退出程序
                                               },
                                               function(){return false;});
                          });
		/* 问题卷选项绑定提示事件 */
		appUtils.preBindEvent($(_pageId+" .user_form")," .icon_radio",function(){
			validateSelect(this);
		});
		
		/* 提交问卷回访 */
		appUtils.bindEvent($(_pageId+" .ct_btn"),function(){
			if($(_pageId+" .icon_check").hasClass("checked")){
				if(appUtils.getSStorageInfo("flag") =="1"){
					subAgreement();
				}else{
					subAgreement_no();
				}
			}else{
				layerUtils.iMsg(-1,"请先签署协议！");
				return false;
			}
//			postQuestionaireData();
		});
		
		/* 绑定同意签署协议 */
		appUtils.bindEvent($(_pageId+" .icon_check"),function(){
			$(this).toggleClass("checked");
		});
	}
	
	function destroy()
	{
		service.destroy();
	}
	
	/* 检测是否安装证书 */
	function checkCert()
	{
		//本页面需要用到证书，如果进入本页面时，证书不存在就下载并安装证书
		var existsParam = {
			"userId" : userId,
			"mediaid" : "certificate",
			"type" : cert_type
		};
		require("shellPlugin").callShellMethod("fileIsExistsPlugin",function(data){
			// 如果未检测到本地有证书，就安装证书
			if(data.mediaId == "")
			{
				utils.installCertificate(getOpenConfirmData);  // 下载安装证书，并且显示问卷和协议
			}
			else
			{
				getOpenConfirmData();  // 显示问卷和协议
			}
		},function(){
			layerUtils.iLoading(false);  // 关闭等待层。。。
		},existsParam);
	}
	
	/*获取问卷回访协议数字证书协议*/
	function queryCertAgreement()
	{
		//中登证书协议：certprotcl 自建证书协议：zjcertprotcl  问卷回访协议 ： wjhfxy
		var getDigitalParam = {"category_englishname" : "wjhfxy"};
		service.queryProtocolList(getDigitalParam,function(data){
			$(_pageId+" #icon_Check").html("已阅读并同意");
			protocol = data.results[0];
			var error_no = data.error_no,
		          error_info = data.error_info;
			if(error_no == 0 && data.results)
			{
				// 《中登个人数字证书申请责任书》
				if(data.results[0] != undefined)
				{
					$(_pageId+" #icon_Check").append("<a href=\"javascript:void(0)\" id=\"questionnaire\" summary="+data.results[0].econtract_md5+
							" protocolid="+data.results[0].econtract_no+">《"+data.results[0].econtract_name+"》</a>");
				}
				// 《电子签名约定书》
//				if(data.results[1] != undefined)
//				{
//					$(_pageId+" #icon_Check").append("<a href=\"javascript:void(0)\" id=\"questionnaire\">《"+data.results[1].econtract_name+"》</a>");
//				}
				// 预绑定查看协议的事件
				appUtils.preBindEvent($(_pageId+" #icon_Check"),"#questionnaire",function(e){
					e.stopPropagation();  // 阻止冒泡
					appUtils.pageInit("account/uploadPhoto","account/showDigitalProtocol",{"protocolId" : data.results[0].econtract_no});
				});
				// 预绑定查看协议的事件
//				appUtils.preBindEvent($(_pageId+" #icon_Check"),"#protocol01",function(e){
//					e.stopPropagation();  // 阻止冒泡
//					appUtils.pageInit("account/uploadPhoto","account/showDigitalProtocol",{"protocolId" : data.results[1].econtract_no});
//				});
			}
			else
			{
				layerUtils.iAlert(data.error_info);
			}
		},true,true,handleTimeout);
	}
	
	/* 处理请求超时 */
	function handleTimeout()
	{
		utils.layerTwoButton("请求超时，是否重新加载？","确认","取消",function(){
               queryCertAgreement();  // 再次获取中登协议
        	}, function(){return false;});
	}
	
	/*获取问卷题目与所选择的答案*/
	function agreementInfo()
	{
		var topicList = "";
		//循环获取题目与所选择的答案
		$(_pageId + " .user_form .items").each(function(i){
			var list = "";
			list = $(this).find("h5").html() + $(this).find(".checked").html()
			topicList = topicList + list + "|";
		});
		return topicList;
	}
	
	/**签署协议提交问卷*/
	function subAgreement(){
		
		if(!validateIfQuestionisFinish())
		{
			return;
		}
		/** 进行协议签署**/
		/*start获取证书密文*/
		var protocolArray = new Array();  // 协议数组
		//获取协议数字签名值
		var summary = $(_pageId + " #questionnaire").attr("summary");  // 协议内容MD5,签名摘要信息
		var protocolid = $(_pageId + " #questionnaire").attr("protocolid");
		var signParam = {
				"medid":protocolid,		//协议ID
				"content":summary,		//协议内容MD5,签名摘要信息
				"userId":userId,		//userId
				"type": cert_type		
			};
		// 获取协议的数字签名值
		require("shellPlugin").callShellMethod("signPlugin",function(data){
			var protocoldcsign = data.ciphertext;  // 数字签名值
			// 添加值到数组中
			var protocol = {
				"protocol_id" : protocolid,
				"protocol_dcsign" : protocoldcsign,
				"summary" : summary,
				"userId":userId,
				"plain_text":agreementInfo(),
				"type": cert_type
			};
			protocolArray.push(protocol);
			
			subSignature(protocolArray); //调用开始验签
		},function(){
			layerUtils.iAlert("系统异常");
			layerUtils.iLoading(false);  // 关闭等待层
		},signParam);
		/*end*/
	}
	
	/*验签*/
	function subSignature(protocolArray)
	{
		layerUtils.iLoading(true);  // 开启等待层......
			// 签署协议
		var signProtocolParam = {
			"user_id" : userId,
			"jsondata" : JSON.stringify(protocolArray),
			"ipaddr" : appUtils.getSStorageInfo("ip"),
			"sign_source_flag" : "2",	
			"checksign" : "1",
			"macaddr" : appUtils.getSStorageInfo("mac")
		};
			// 新开中登验签
			if(appUtils.getSStorageInfo("openChannel") == "new")
			{
				service.zdChekedSign(signProtocolParam,postQuestionaireData,false);
			}
			// 转户天威验签
			else if(appUtils.getSStorageInfo("openChannel") == "change")
			{
				service.twChekedSign(signProtocolParam,postQuestionaireData,false);
			}
	}
	
	function subAgreement_no(){
		if(!validateIfQuestionisFinish())
		{
			return;
		}
		/** 进行协议签署**/
		/*start获取证书密文*/
		var protocolArray = new Array();  // 协议数组
		//获取协议数字签名值
		var summary = $(_pageId + " #questionnaire").attr("summary");  // 协议内容MD5,签名摘要信息
		var protocolid = $(_pageId + " #questionnaire").attr("protocolid");
		// 添加值到数组中
		var protocol = {
			"protocol_id" : protocolid,
			"protocol_dcsign" : "",
			"summary" : summary,
			"userId":userId,
			"plain_text":agreementInfo(),
			"type": cert_type
		};
		protocolArray.push(protocol);
		subSignature_no(protocolArray); //调用开始验签
	}
	
	function subSignature_no(protocolArray){

		layerUtils.iLoading(true);  // 开启等待层......
			// 签署协议
		var signProtocolParam = {
			"user_id" : userId,
			"jsondata" : JSON.stringify(protocolArray),
			"ipaddr" : appUtils.getSStorageInfo("ip"),
			"sign_source_flag" : "2",	
			"checksign" : "0",
			"macaddr" : appUtils.getSStorageInfo("mac")
		};
		// 新开中登验签
		if(appUtils.getSStorageInfo("openChannel") == "new")
		{
			service.zdChekedSign(signProtocolParam,postQuestionaireData,false);
		}
		// 转户天威验签
		else if(appUtils.getSStorageInfo("openChannel") == "change")
		{
			service.twChekedSign(signProtocolParam,postQuestionaireData,false);
		}

	}
	
	/* 选项选中验证事件，若选择否 则按钮不可点击 */
	function validateSelect(obj)
	{
		// 若当前点击没有选中，去除全部选中
		if(!$(obj).hasClass("checked"))
		{
			$(obj).parent().siblings().children("a").removeClass("checked");  // 选中当前答案，将其他答案标记未选择
			$(obj).parent().parent().prev("h5").css("color","#666666");	 // 红色标记恢复黑色
		}
		else
		{
			$(obj).parent().parent().prev("h5").css("color","red");  //未选择答案，则将该题标记为红色
		}
		$(obj).toggleClass("checked");
	}
	
	/* 获取开户确认回访问卷 */
	function getOpenConfirmData()
	{
		$(_pageId+" .user_form").html("");
		var visitSubParam = {
			"user_id":userId,
			"sub_id":"5000"
		};
		// 获取回访问卷题目
		service.getVisitSub(visitSubParam,function(data){
			var errorNo   = data.error_no;
			var errorInfo = data.error_info;
			if(errorNo == 0 && data.results.length != 0)	//调用成功
			{
				var results = data.results;
				var questionHtml = "";
				for(var i =0; i<results.length; i++)  // 先遍历
				{
					var oneEle = results[i];
					var queid = oneEle.que_id;
					var type = oneEle.type;
					var qname = oneEle.q_name;
					var str = type+"-"+queid+"-"+qname;
					var secondMap = null;
					if(!fristMap.containsKey(str)) // 若map中没有对应的问题号，则存入问题号
					{
						secondMap = new Map();
						secondMap.put(oneEle.ans_id,oneEle);
						fristMap.put(str, secondMap);	// fristMap每一个Key对应一个问题
					}
					else
					{
						fristMap.get(str).put(oneEle.ans_id,oneEle);
					}
				}
				var keys = fristMap.keys();
				for(var j=0; j<keys.length; j++)
				{
					var oneData  = fristMap.get(keys[j]);//取出一个问题
					questionHtml += createOpenConfirmElement(oneData,keys[j],j+1);
				}
				$(_pageId+" .user_form").html(questionHtml);
				// 当题目过多，则设置下一步按钮悬浮底部
				$(_pageId+" .fix_bot").css("position","fixed");
				// 设置默认值，默认选择正确答案
				$(_pageId+" .user_form dl a[ans-mark=1]").addClass("checked");
				//获取问卷回访协议数字证书协议
				queryCertAgreement();
			}
			else
			{
				layerUtils.iAlert(errorInfo);
			}
		},true,true,handleTimeout);
	}
	
	/* 处理请求超时 */
	function handleTimeout()
	{
		layerUtils.iConfirm("请求超时，是否重新加载？",function(){
			getOpenConfirmData();  // 再次获取问卷回访题目
		});
	}
	
	/* 创建一个问题项目 */
	function createOpenConfirmElement(oneData,key,index)
	{
		var type  = key.split("-")[0];
		var queid = key.split("-")[1];
		var qname = key.split("-")[2];
		var oneDatakeys = oneData.keys();
		var itemHtml = "";
		var itemHead = "";
		var itemElem = "";
		for(var i =0; i<oneDatakeys.length; i+=3) // 先遍历确定有多少题
		{
			var oneElem = oneData.get(oneDatakeys[i]);
			var mark  = oneElem.mark;
			var aname = oneElem.a_name;
			var ansid = oneElem.ans_id;
			itemElem += "<dd><a href=\"javascript:;\" class=\"icon_radio\" que-choice='0' que-type ='"+type+"' ans-id='"+ansid+"' ans-mark=\""+mark+"\" id ='"+queid+"'>"+aname+"</a></dd>";
			if(oneDatakeys.length >= 2 ) // 取第二条数据
			{
				var oneEleTwo = oneData.get(oneDatakeys[i+1]);
				var markTwo  = oneEleTwo.mark;
				var anameTwo = oneEleTwo.a_name;
				var ansidTwo = oneEleTwo.ans_id;
				itemElem += "<dd><a href=\"javascript:;\" class=\"icon_radio\" que-choice='1' que-type ='"+type+"' ans-id='"+ansidTwo+"' ans-mark=\""+markTwo+"\" id ='"+queid+"'>"+anameTwo+"</a></dd>";
				if(oneDatakeys.length >= 3 )  // 取第三条数据
				{
					var oneEleThree = oneData.get(oneDatakeys[i+2]);
					var markThree  = oneEleThree.mark;
					var anameThree = oneEleThree.a_name;
					var ansidThree = oneEleThree.ans_id;
					itemElem += "<dd><a href=\"javascript:;\" class=\"icon_radio\" que-choice='1' que-type ='"+type+"' ans-id='"+ansidThree+"' ans-mark=\""+markThree+"\" id ='"+queid+"'>"+anameThree+"</a></dd>";
				}
			}
		}
		itemHead = "<h5 class=\"title\">"+index+"、 "+qname+"</h5>";
		itemHtml = "<div class=\"items\">"+itemHead+"<dl class=\"radio_table\" id="+queid+">"+itemElem+"</dl></div>";
		return itemHtml;
	}
	
	/* 提交问卷回访数据（用户选择答案） */
	function postQuestionaireData()
	{
		oneQuestionaireData ="";	// 格式如：1_2_7|2_7_3|  问题ID_答案ID_答案分值
		oneQuestionaireData = validateIfQuestionisFinish();
		if(!oneQuestionaireData)
		{
			return false;
		}
		var submitParam = {
			"user_id":userId,
			"q_a_args":oneQuestionaireData,
			"sub_id":"5000"
		};
		$(_pageId+" .user_form h5").css("color","#666666");	// 红色标记恢复黑色
		service.submitVisitAnswer(submitParam,function(data){
			var errorNo = data.error_no;
			var errorInfo = data.error_info;
			if(errorNo==0)	 // 调用成功,跳转到风险测评页面
			{
				appUtils.pageInit("account/openConfirm","account/receiptInfo",{});  // 回执跑批
			}
			else
			{
				layerUtils.iAlert(errorInfo, -1);
			}
		});
	}
	
	/* 验证问题全部是否回答 */
	function validateIfQuestionisFinish()
	{
		var oneRiskAssessData ="";
		var countNoChoice = 0; // 没有选择问题数量
		var numNoChoice  =""; // 没有选择问题题号
		var keys = fristMap.keys();
		for(var j=0; j<keys.length; j++)
		{
			var queid = keys[j].split("-")[1];
			var isChoice = false;
			$(_pageId+" .radio_table dd #"+queid).each(function (){
				if($(this).hasClass("checked"))
				{
					isChoice = true;
					var ansid = $(this).attr("ans-id");
					var mark  = $(this).attr("ans-mark");
					oneRiskAssessData +=(queid+"_"+ansid+"_"+mark+"|");
				}
			});
			// 校验不规范答题
			if(!isChoice || !$(_pageId+" .radio_table:eq("+j+") dd a[ans-mark='1'] ").hasClass("checked"))
			{
				countNoChoice++;
				numNoChoice +=(j+1)+"、";
			}
		}
		if(countNoChoice>0) // 您的答题尚未完成
		{
			numNoChoice=numNoChoice.substring(0,numNoChoice.length-1); // 去掉最后一个逗号
			layerUtils.iAlert("亲！您如下答题编号：【"+numNoChoice+"】 无法通过问卷回访，请重新作答");
			return false;
		}
		return oneRiskAssessData;
	}
	
	var questionnaireReturn = {
		"init" : init,
		"bindPageEvent" : bindPageEvent,
		"destroy" : destroy
	};
	
	module.exports = questionnaireReturn;
});