/**
 * 填写个人信息
 */
define("project/scripts/account/receiptInfo",function(require, exports, module){ 
	/* 私有业务模块的全局变量 begin */
	var appUtils = require("appUtils"),
	    service = require("serviceImp").getInstance(),  //业务层接口，请求数据
		global = require("gconfig").global,
		layerUtils = require("layerUtils"),
		utils = require("utils"),
		manId = "",
		womenId = "",
		validatorUtil = require("validatorUtil"),
		idCardModify = false,  // 身份证是否被手工修改
		_pageId = "#account_receiptInfo";
	/* 私有业务模块的全局变量 end */
	
	function init()
	{
		pageInit();
	}
	
	//初始化页面，显示用户回执信息
	function pageInit(){
       if(global.isSubSystem == "1")
       $(_pageId+" .header .icon_close").show();
		var param ={"user_id" : appUtils.getSStorageInfo("user_id")};
		service.findReceiptInfo(param,function(data){
			$(_pageId+" input").attr("disabled","disabled");
			var result = data.results[0];
			var error_no = data.error_no;
			if(error_no == 0 && result != ""){
				var usersex = result.usersex;
				if(usersex == "0"){
					usersex = "男";
				}else{
					usersex = "女";
				}
				$(_pageId+" .name").val(result.custname);  // 客户姓名
				$(_pageId+" .idCardNo").val(result.idno);	 // 身份证号
				$(_pageId+" .usersex").val(usersex);	 // 性别
				$(_pageId+" .idCardAddress").val(result.native);	// 证件地址
				$(_pageId+" .native").val(result.native);	// 联系地址和证件地址设置相同的
				$(_pageId+" .address").val(result.addr);	// 联系地址和证件地址设置相同的
				$(_pageId+" .idBeginDate").val(result.idenddate);  //结束期限
				$(_pageId+" .zipCode").val(result.postid);  //邮编
				$(_pageId+" .mobileno").val(result.mobileno);  //移动电话
				$(_pageId+" .birthday").val(result.birthday);  //出生年月
				$(_pageId +" #banknumber").html(result.banknumber);
				$(_pageId +" #bankname").html(result.bankname);
				
				if(appUtils.getSStorageInfo("openChannel") == "new")
				{
					
					if(result.shaselect == "2"){
						$(_pageId +" #ha").html("新开");
					}
					if(result.szaselect == "2"){
						$(_pageId +" #sa").html("新开");
					}
					if(result.shfund_select == "1"){
						$(_pageId +" #hjj").html("新开");
					}
					if(result.szfund_select == "1"){
						$(_pageId +" #sjj").html("新开");
					}
				}
				else if(appUtils.getSStorageInfo("openChannel") == "change")
				{
					if(result.shaselect == "2"){
						$(_pageId +" #ha").html("转户");
					}
					if(result.szaselect == "2"){
						$(_pageId +" #sa").html("转户");
					}
					if(result.shfund_select == "1"){
						$(_pageId +" #hjj").html("转户");
					}
					if(result.szfund_select == "1"){
						$(_pageId +" #sjj").html("转户");
					}
				}
			}else{
				layerUtils.iLoading(false);  // 关闭等待层。。。
				layerUtils.iAlert(data.error_info);
			}
			
		},true,true,handleTimeout);
	}
	/* 处理请求超时 */
	function handleTimeout()
	{
		utils.layerTwoButton("请求超时，是否重新加载？","确认","取消",function(){
               pageInit();  // 
        	}, function(){return false;});
	}
	
	function bindPageEvent()
	{
		appUtils.bindEvent($(_pageId+" .fix_bot .ct_btn"),function(){
			joinQueue();	//跑批处理
		});
       /* 绑定退出按钮*/
       appUtils.bindEvent($(_pageId+" .header .icon_close"),function(){
                          utils.layerTwoButton("退出手机开户？","确认","取消",function(){
                                               require("shellPlugin").callShellMethod("closeAppPlugin",null,null);  // 退出程序
                                               },
                                               function(){return false;});
                          });
	}
	function joinQueue(){
		var param ={"user_id" : appUtils.getSStorageInfo("user_id")};
		service.joinQueue(param,function(data){
				if(data.error_no == 0){
					appUtils.pageInit("account/receiptInfo","account/accountResult",{});  //跳到结果页
				}else{
					layerUtils.iLoading(false);  // 关闭等待层。。。
					layerUtils.iAlert(data.error_info);
				}
		});
	}
	function destroy()
	{
		service.destroy();
	}
	
	/*提交开户信息*/
	function submitInfo()
	{}
	
	var receiptInfo = {
		"init" : init,
		"bindPageEvent" : bindPageEvent,
		"destroy" : destroy
	};
	
	module.exports = receiptInfo;
});