/**
 * 选择营业部
 */
define("project/scripts/account/selDepartment",function(require, exports, module){ 
	/* 私有业务模块的全局变量 begin */
	var appUtils = require("appUtils"),
		   service = require("serviceImp").getInstance(),  //业务层接口，请求数据
	       global = require("gconfig").global,
       utils = require("utils"),
	       layerUtils = require("layerUtils"),
	       shellPlugin = require("shellPlugin"),
	       regionIdList = ['1','4','5','6','3'],
	       regionList = ['华中地区','华东地区','华南地区','北方地区','西部地区'],  //地区
		   cityList = "",  //城市
		   branchList = "",  //营业部
		   localRegion = "",  // 地区
		   localCity = "",  // 本地城市
		   localBranch = "",  // 本地营业部
		   branchParam={"branchno" : "","branchname":"","lat":"","lnt":"","address":"","traininfo":""},  //营业部编号
		   _pageId = "#account_selDepartment";
	/* 私有业务模块的全局变量 end */
	
	function init()
	{
		initPage();  // 初始化页面
	}
	
	function bindPageEvent()
	{
		/* 绑定返回 */
		appUtils.bindEvent($(_pageId+" .header .icon_back"),function(){
			appUtils.pageBack();
		});
       
       /* 绑定退出按钮*/
       appUtils.bindEvent($(_pageId+" .header .icon_close"),function(){
                          utils.layerTwoButton("退出手机开户？","确认","取消",function(){
                                               require("shellPlugin").callShellMethod("closeAppPlugin",null,null);  // 退出程序
                                               },
                                               function(){return false;});
                          });

		/* 绑定查看营业部地图 */
		appUtils.bindEvent($(_pageId+" .personinfo_tip"),function(){
			var branch_name = $(_pageId+" .mobile_form .sel_branch").text();
			if(branch_name == "请选择营业部")
			{
				layerUtils.iMsg(-1,"请选择开户营业部");
				return;
			}
			var param = {"branchno":branchParam.branchno};
			service.getBranchName(param,function(data){
				var error_no = data.error_no;
				var error_info = data.error_info;
				var result = data.results[0];
				if(error_no == "0" && result!=null && result!="" && typeof (result)!=undefined)
				{
					branchParam.lat = result.lat;
					branchParam.lnt = result.lnt;
					branchParam.branchname = result.branchname;
					branchParam.address = result.address;
					branchParam.trainfo = result.trainfo;
					if(branchParam.lat != null && branchParam.lat != "" && typeof (branchParam.lat)!=undefined)
					{
						appUtils.pageInit("account/selDepartment","account/branchMap", branchParam);
					}
					else
					{
						layerUtils.iMsg(-1,"没有该营业部位置信息");
					}
				}else{
					layerUtils.iAlert(error_info,-1);
				}

			});
		});


				
		/* 点击页面其他元素隐藏下拉列表 */
		appUtils.bindEvent($(_pageId),function(e){
			$(_pageId+" .sel_list").slideUp("fast");	// 隐藏下拉列表
			e.stopPropagation();	// 阻止冒泡
		});
		
		/* 绑定选择地区 */
		appUtils.bindEvent($(_pageId+" .mobile_form .sel_region"),function(e){
			$(_pageId+" .city").hide();  //隐藏城市列表
			$(_pageId+" .branch").hide();  //隐藏营业部列表
			$(_pageId+" .region ul li").removeClass("active");
			$(_pageId+" .region").slideToggle("fast");	 // 显示选择地区的下拉列表
			e.stopPropagation();	// 阻止冒泡
		});
		
		/* 绑定选择城市 */
		appUtils.bindEvent($(_pageId+" .mobile_form .sel_city"),function(e){
			$(_pageId+" .region").hide();  //隐藏省份列表
			$(_pageId+" .branch").hide();  //隐藏营业部列表
			$(_pageId+" .city ul li").removeClass("active");
			$(_pageId+" .city").slideToggle("fast");	// 显示选择城市的下拉列表
			e.stopPropagation();	// 阻止冒泡
		});
		
		/* 绑定选择营业部 */
		appUtils.bindEvent($(_pageId+" .mobile_form .sel_branch"),function(e){
			$(_pageId+" .region").hide();  //隐藏省份列表
			$(_pageId+" .city").hide();  //隐藏城市列表
			$(_pageId+" .branch ul li").removeClass("active");
			$(_pageId+" .branch").slideToggle("fast");	// 显示选择营业厅的下拉列表
			e.stopPropagation();	// 阻止冒泡
		});
		
		/* 绑定下一步 */
		appUtils.bindEvent($(_pageId+" .fix_bot .ct_btn"),function(){
			var region_name =$(_pageId+" .mobile_form .sel_region").text();
			var city_name =$(_pageId+" .mobile_form .sel_city").text();
			var branch_name = $(_pageId+" .mobile_form .sel_branch").text();
			if(region_name == "请选择地区")
			{
				layerUtils.iMsg(-1,"请先选择开户地区");
				return false;
			}
			if(city_name == "请选择城市")
			{
				layerUtils.iMsg(-1,"请先选择开户城市");
				return false;
			}
			if(branch_name == "请选择营业部")
			{
				layerUtils.iMsg(-1,"请选择开户营业部");
				return false;
			}
			//确定营业部
			appUtils.pageInit("account/selDepartment","account/personInfo");
		});
	}
	
	function destroy()
	{
		service.destroy();
	}
	
	/* 初始化页面 */
	function initPage()
	{
       if(global.isSubSystem == "1")
       $(_pageId+" .header .icon_close").show();
		cleanPageElement(); // 清理页面元素值
		var Branch_no = appUtils.getSStorageInfo("branchno"); // 用户已选营业部id
		var Branch_name = appUtils.getSStorageInfo("branchname");  // 用户已选营业部名称
		var Region_name = appUtils.getSStorageInfo("regionname");  // 用户已选地区
		var City_name = appUtils.getSStorageInfo("cityname");  // 用户已选城市
		getRegionList();
		//  用户如果已选择了营业部，就不需要定位
		if(Region_name && City_name && Branch_name)
		{
			localRegion = Region_name;
			localCity = City_name;
			localBranch = Branch_name;
			branchParam.branchno = Branch_no;
			$(_pageId+" .sel_region").html(Region_name);
			$(_pageId+" .sel_city").html(City_name);
			$(_pageId+" .sel_branch").html(Branch_name);
		}
		else
		{
            if(City_name){
                localCity = City_name;
                $(_pageId+" .sel_city").html(City_name);
                getRegionByCity(City_name);
            }
            else
                getPosition();  // 进行地理定位
		}
	}
	
	/* 定位本地地址 */
	function getPosition()
	{
		//获取地址
		shellPlugin.callShellMethod("getLocationInfoPlugin",function(result){
			localCity = result.City;
			if(localCity != "" &&(typeof(localCity)!="undefined"))
			{
				getRegionByCity(localCity);
			}
         },function(result){

         } );
	}

	function getRegionByCity(cityname)
	{
		var param = {"cityName":cityname};
		service.getRetinAndCityID(param, function(data) {
			var error_no = data.error_no;
			var error_info = data.error_info;
			var result = data.results[0];
			if(error_no=="0" && result != "" &&(typeof(result)!="undefined"))
			{
				var region_id = result.region_id;
				var cityId = result.city_id;
				localRegion = getRegionNameById(region_id);
				if(localRegion!="")
				{
					getCityList(region_id);
					getBranchList(cityId);
					$(_pageId + " .sel_region").text(localRegion);
					$(_pageId+" .sel_city").text(localCity);
				}
			}
			else
			{
				layerUtils.iMsg(-1,"您当前所处城市无相关营业部，请手动选择");  //提示错误信息
			}
		},true,true,handleTimeout);

	}

	function getRegionNameById(region_Id)
	{
		var region = "";
		var rlen = regionIdList.length;
		// 遍历省份集合
		for(var i=0; i<rlen; i++) {
			if(region_Id == regionIdList[i])
			{
				region = regionList[i];
				return region;
			}
		}
		return region;
	}

	/* 获取营业部List */
	function getRegionList()
	{
		var rlen = regionList.length;
	    var region_str = "", regionId = "", regionName = "";
		// 遍历省份集合
		for(var i=0; i<rlen; i++)
		{
			regionId = regionIdList[i]; // 地区id
			regionName = regionList[i];  // 地区名称
			region_str += "<li rid='"+regionId+"'><span>"+regionName+"</span></li>";
			$(_pageId+" .region ul").html(region_str);  // 填充地区下拉框
		}
		bindRegion();//点击地区
	}

	//根据区域获取城市列表
	function getCityList(regionId)
	{
		var param = {"quyuno":regionId};
		$(_pageId+" .city ul").html("");  //填充城市下拉框
		var city_str = "";
		//获取城市列表
		service.getCityNames(param, function(data){
			var error_no = data.error_no;
			var cityList = data.results;
			if(error_no=="0" && cityList != "" &&(typeof(cityList)!="undefined"))
			{
				// 填充选中地区下的所有城市
				for(var j=0; j<cityList.length; j++)
				{
					city_str += "<li cid='" + cityList[j].cityid + "'><span>" + cityList[j].cityname + "</span></li>";
					$(_pageId+" .city ul").html(city_str);  // 填充城市下拉框
				}
				$(_pageId+" .city ul").html(city_str);  //填充城市下拉框
				bindCity();
			}
		},false,false);
	}

	//根据城市获取营业部列表
	function getBranchList(cityId)
	{
		var branch_str = ""
		var param ={"cityno":cityId};
		$(_pageId+" .branch ul").html("");
		service.getBranchNos(param, function(data) {
			var error_no = data.error_no;
			branchList = data.results;
			if(error_no=="0" && branchList != "" &&(typeof(branchList)!="undefined"))
			{
				//选中城市立即填充相应营业部
				var branchno = "",branchname="";
				for(var i=0; i<branchList.length; i++)
				{
					branchno = branchList[i].branchno;
					branchname = branchList[i].branchname;
					branch_str+= "<li bid='"+branchno+"'><span>"+branchname+"</span></li>";
					$(_pageId+" .branch ul").html(branch_str);  //填充营业部下拉框
				}
				$(_pageId+" .branch ul").html(branch_str);  //填充营业部下拉框
				if(branchList.length == 1)
				{
					$(_pageId + " .sel_branch").text(branchname);
					appUtils.setSStorageInfo("branchname",branchname);
					appUtils.setSStorageInfo("branchno",branchno);
                     branchParam.branchno = branchno;
				}
				bindBranch();  //点击营业部
			}
		},false,false);
	}

	/* 处理请求超时 */
	function handleTimeout()
	{
		utils.layerTwoButton("请求超时，是否重新加载？","确认","取消",function(){
               if(localCity == "")
			{
				getPosition();  // 再次获取营业部
			}
			else
			{
				getRegionByCity(localCity);
			}
        	}, function(){return false;});
	}

	/* 选中省份事件处理 */
	function bindRegion()
	{
		appUtils.bindEvent($(_pageId+" .region ul li"),function(e){
			$(this).addClass("active").siblings().removeClass("active");
			var regionname = $(this).text();  //当前选中地区的值
			var sel_rname = $(_pageId+" .sel_region").text();  //上一次选中地区的值
			$(_pageId+" .sel_region").text(regionname);	  //将选中值赋给选择框
			appUtils.setSStorageInfo("regionname",regionname);
			$(_pageId+" .region").slideUp("fast");	//隐藏下拉框
			 //再次点击相同省份,下级菜单不改变，否则重置
			if(regionname != sel_rname)
			{
				$(_pageId+" .sel_city").text("请选择城市");
				$(_pageId+" .sel_branch").text("请选择营业部");
				$(_pageId+" .branch ul").html("");
			}
			//填充城市列表
			getCityList($(this).attr("rid"));
			e.stopPropagation();	// 阻止冒泡
		});
	}
	
	/* 选中城市事件绑定 */
	function bindCity()
	{
		appUtils.bindEvent($(_pageId+" .city ul li"),function(e)
		{
			$(this).addClass("active").siblings().removeClass("active");
			var cityname = $(this).text();  //当前选择城市的值
			var sel_cname = $(_pageId+" .sel_city").text();  //上次选择城市的值
			$(_pageId+" .sel_city").text(cityname);	  //选中值赋给选择框
			appUtils.setSStorageInfo("cityname",cityname);
			$(_pageId+" .city").slideUp("fast");	//隐藏下拉框
			//再次点击相同城市,下级菜单不改变，否则重置
			if(sel_cname != cityname)
			{
				$(_pageId+" .sel_branch").text("请选择营业部");
			}
			//选中城市立即填充相应营业部
			getBranchList($(this).attr("cid"));
			e.stopPropagation();	// 阻止冒泡
		});
	}
	
	/* 选中营业部事件绑定*/
	function bindBranch()
	{
		appUtils.bindEvent($(_pageId+" .branch ul li"),function(e){
			var bid = $(this).attr("bid");
			$(this).addClass("active").siblings().removeClass("active");
			var branchname = $(this).text();  //当前选中营业部的值
			var sel_bname = $(_pageId+" .sel_branch").text();  //上一次选中营业部的值
			$(_pageId+" .sel_branch").attr("branchcode",bid);
			$(_pageId+" .sel_branch").text(branchname);	  //选中值赋给选择框
			branchParam.branchno = bid;
			branchname.branchname = branchname;
			appUtils.setSStorageInfo("branchname",branchname);
			appUtils.setSStorageInfo("branchno",bid);
			$(_pageId+" .branch").slideUp("fast");	//隐藏下拉框
			e.stopPropagation();	// 阻止冒泡
		});	
	}
	
	/* 清理界面元素 */
	function cleanPageElement()
	{
		//$(_pageId+" .header .icon_back").hide(); //隐藏返回按钮
		$(_pageId+" .sel_region").text("请选择地区");
		$(_pageId+" .sel_city").text("请选择城市");
		$(_pageId+" .sel_branch").text("请选择营业部");
	}
	var selDepartment = {
		"init" : init,
		"bindPageEvent" : bindPageEvent,
		"destroy" : destroy
	};
	
	// 暴露对外的接口
	module.exports = selDepartment;
});